##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE=1 0 3 4 6 7 8 13 14 15 16 19 20 23 25 26
PALETTE_MENU=1 0 3 4 6 7 12 13 14 12 16 19 20 23 25 26
PALETTE_LEVEL_1=11 0 3 4 6 7 8 13 14 15 16 19 20 23 25 26
PALETTE_LEVEL_2=2 0 3 4 6 7 8 13 14 15 16 19 20 23 25 26
PALETTE_LEVEL_3=1 0 3 4 6 7 8 13 14 15 16 19 20 23 25 26

PALETTE_PULSE_1 = 5 1 2 3 6 9 11 12 13 15 16 20 24 25 26 0
PALETTE_PULSE_2 = 8 1 2 3 6 9 11 12 13 15 16 20 24 25 26 0

PALETTE_DAMAGE=3 0 1 4 6 7 8 13 14 15 16 19 20 23 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

$(eval $(call IMG2SP, SET_FOLDER      , src/sprites))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_MENU), palette_menu))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_LEVEL_1), palette_level_1))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_LEVEL_2), palette_level_2))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_LEVEL_3), palette_level_3))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_PULSE_1), palette_pulse_1))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_PULSE_2), palette_pulse_2))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_DAMAGE), palette_damage))
$(eval $(call IMG2SP, CONVERT         , assets/vacio.png , 0, 0, spr_vacio))
$(eval $(call IMG2SP, CONVERT         , assets/submarino.png , 0, 0, spr_playership))
$(eval $(call IMG2SP, CONVERT         , assets/submarino_up.png , 0, 0, spr_playership_up))
$(eval $(call IMG2SP, CONVERT         , assets/submarino_down.png , 0, 0, spr_playership_down))
$(eval $(call IMG2SP, CONVERT         , assets/player-shot.png , 6, 2, spr_player_shot))
$(eval $(call IMG2SP, CONVERT         , assets/enemy-shot-1.png , 4, 2, spr_enemy_shot1))
$(eval $(call IMG2SP, CONVERT         , assets/enemy-big-shot.png , 0, 0, spr_enemy_big_shot))
$(eval $(call IMG2SP, CONVERT         , assets/follow.png , 4, 4, spr_follow_shot))
$(eval $(call IMG2SP, CONVERT         , assets/boss_crab_0.png ,0, 0, spr_boss_crab_0))
$(eval $(call IMG2SP, CONVERT         , assets/boss_crab_1.png ,0, 0, spr_boss_crab_1))
$(eval $(call IMG2SP, CONVERT         , assets/boss_crab_shot.png ,0, 0, spr_boss_crab_shot))
$(eval $(call IMG2SP, CONVERT         , assets/boss_squid_0.png ,0, 0, spr_boss_squid_0))
$(eval $(call IMG2SP, CONVERT         , assets/boss_squid_1.png ,0, 0, spr_boss_squid_1))
$(eval $(call IMG2SP, CONVERT         , assets/boss_squid_shot.png ,0, 0, spr_boss_squid_shot))
$(eval $(call IMG2SP, CONVERT         , assets/tentaculo.png ,8, 20, spr_boss_squid_tentaculo))
$(eval $(call IMG2SP, CONVERT         , assets/puffer_fish.png ,10, 24, spr_puffer_fish))
$(eval $(call IMG2SP, CONVERT         , assets/anguila.png ,20, 36, spr_anguila))
$(eval $(call IMG2SP, CONVERT         , assets/starfish.png ,10, 24, spr_starfish))
$(eval $(call IMG2SP, CONVERT         , assets/depths_fish.png ,10, 40, spr_depths_fish))
$(eval $(call IMG2SP, CONVERT         , assets/jellyfish.png ,10, 20, spr_jellyfish))
$(eval $(call IMG2SP, CONVERT         , assets/pez_pelicano.png ,20, 36, spr_pez_pelicano))
$(eval $(call IMG2SP, CONVERT         , assets/mecha_kraken_1.png ,0, 0, spr_mecha_kraken_0))
$(eval $(call IMG2SP, CONVERT         , assets/mecha_kraken_2.png ,0, 0, spr_mecha_kraken_1))
$(eval $(call IMG2SP, CONVERT         , assets/mecha_kraken_shot.png ,0, 0, spr_mecha_kraken_shot))
$(eval $(call IMG2SP, CONVERT         , assets/torpedo.png ,8, 8, spr_torpedo))
$(eval $(call IMG2SP, CONVERT         , assets/wheel.png ,14, 16, spr_wheel))
$(eval $(call IMG2SP, CONVERT         , assets/flotador.png ,14, 16, spr_flotador))
$(eval $(call IMG2SP, CONVERT         , assets/mecha_kraken_tentaculo_up_punta.png ,12, 24, spr_mecha_kraken_tentaculo_up_punta))
$(eval $(call IMG2SP, CONVERT         , assets/mecha_kraken_tentaculo_down_punta.png ,12, 24, spr_mecha_kraken_tentaculo_down_punta))
$(eval $(call IMG2SP, CONVERT         , assets/nautilus.png ,16, 24, spr_nautilus))
$(eval $(call IMG2SP, CONVERT         , assets/mecha_chalote.png ,24, 28, spr_mecha_chalote))
$(eval $(call IMG2SP, CONVERT         , assets/enemy-mega-shot.png ,0, 0, spr_enemy_mega_shot))
$(eval $(call IMG2SP, CONVERT         , assets/larcenas.png ,30, 30, spr_larcenas))
$(eval $(call IMG2SP, CONVERT         , assets/mina.png ,14, 16, spr_mina))
$(eval $(call IMG2SP, CONVERT         , assets/rocks.png ,0, 0, spr_rocks))
$(eval $(call IMG2SP, CONVERT         , assets/explosion.png ,10, 20, spr_explosion))
$(eval $(call IMG2SP, CONVERT         , assets/title.png ,90, 36, spr_title))

##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
