;MIT License
;
;Copyright (c) 2022 cabbage_corp / Alberto Rius Poveda (@ariusp) / Alfonso Ruiz MartÃ­nez (@NexiriusRM) / Eliseo Fuentes MartÃ­nez (@efm18)
;
;Permission is hereby granted, free of charge, to any person obtaining a copy
;of this software and associated documentation files (the "Software"), to deal
;in the Software without restriction, including without limitation the rights
;to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;copies of the Software, and to permit persons to whom the Software is
;furnished to do so, subject to the following conditions:
;
;The above copyright notice and this permission notice shall be included in all
;copies or substantial portions of the Software.
;
;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;SOFTWARE.

;CPCTELERA GLOBALS
 ;.globl cpct_disableFirmware_asm
 .globl cpct_waitVSYNC_asm
 .globl cpct_getRandom_mxor_u8_asm
 .globl cpct_memcpy_asm
 .globl cpct_getScreenPtr_asm
 .globl cpct_setVideoMode_asm
 .globl cpct_setPALColour_asm
 .globl cpct_setPalette_asm
 .globl cpct_memset_asm
 .globl cpct_scanKeyboard_asm
 .globl cpct_scanKeyboard_if_asm
 .globl cpct_isKeyPressed_asm
 .globl cpct_isAnyKeyPressed_asm
 .globl cpct_drawSprite_asm
 .globl cpct_drawSolidBox_asm
 .globl cpct_akp_musicInit_asm
 .globl cpct_akp_musicPlay_asm
 .globl cpct_setDrawCharM0_asm
 .globl cpct_drawStringM0_asm
 .globl cpct_drawCharM0_asm
 .globl cpct_setVideoMemoryPage_asm
;

;MUSIC GLOBALS
  .globl _stage1_song
  .globl _stage2_song
  .globl _stage3_song
  .globl _menu_song
  .globl _victory_song
  .globl _death_song

;MANAGER GLOBALS
 ;ENTITY GLOBALS
  .globl man_entity_init
  .globl man_entity_create
  .globl man_entity_freeSpace
  .globl man_entity_update
  .globl man_entity_destroy
  .globl man_entity_forAll
  .globl man_entity_forAll_matching
  .globl man_entity_set4Destruction
  .globl man_entity_setRelativePos
  .globl man_entity_no_enemies
  .globl player
  ;;.globl man_entity_forAllPairs_matching
  .globl man_entity_clone
  ;ENEMY GLOBALS
  ;PLAYER GLOBALS
  ;SHOT GLOBALS
 ;GAME GLOBALS
  .globl man_game_init
  .globl man_game_play
  .globl man_game_create_template_entity
  .globl man_game_setGameState
  .globl man_game_getGameState
  ;;.globl man_game_create_enemy
  .globl man_game_player_shot
  ;;.globl man_game_enemy_lane_down
  ;;.globl man_game_entity_destroy
  .globl man_game_enemy_create_floating_enemy
  .globl man_game_enemy_shot
  .globl man_game_enemy_vertical_shot
  .globl man_game_enemy_4_shot
  ;;.globl man_game_enemy_dash
  .globl man_game_getInputOption
  .globl man_game_setInputOption
  .globl score
  .globl uscor
 ;ANIMATION GLOBALS
  .globl man_anim_follow
  .globl man_anim_boss_crab
  .globl man_anim_boss_squid
  .globl man_anim_boss_squid_tentacle
  .globl man_anim_boss_mecha_kraken
  .globl man_anim_enemy_puffer_fish
  .globl man_anim_enemy_anguila
  .globl man_anim_enemy_starfish
  .globl man_anim_enemy_deptsh_fish
  .globl man_anim_enemy_jellyfish
  .globl man_anim_enemy_pez_pelicano
  .globl man_anim_wheel
  .globl man_anim_mina
  .globl man_anim_larcenas
  .globl man_anim_flotador
  .globl man_anim_enemy_nautilus
  .globl man_anim_enemy_mecha_chalote
  .globl man_anim_boss_mecha_kraken_tentacle_up_punta
  .globl man_anim_boss_mecha_kraken_tentacle_down_punta
  .globl man_anim_explosion
 ;LEVEL GLOBALS
  .globl man_level_init
  .globl man_level_setup
  .globl man_level_update
  .globl man_level_isOver
  .globl current_level
 ;MENU GLOBALS
  .globl man_menu_screen
  .globl man_menu_handler
  .globl man_menu_gameOver
  .globl man_menu_endCard
;

;SYSTEM GLOBALS
 ;PHYSICS GLOBALS
  .globl sys_physics_update
 ;RENDER GLOBALS
  .globl sys_render_update
  .globl sys_render_init
  .globl sys_render_pulse_palette
  .globl sys_render_damage_palette
  .globl sys_render_set_level_palette
 ;AI GLOBALS
  .globl sys_ai_entities_init
  .globl sys_ai_movements_init
  .globl sys_ai_behaviour_left_right
  .globl sys_ai_behaviour_up_down
  .globl sys_ai_behaviour_vertical_dashes
  .globl sys_ai_behaviour_teleport
  .globl sys_ai_behaviour_circle
  .globl sys_ai_behaviour_enemy_follow
  .globl sys_ai_behaviour_follow
  .globl sys_ai_behaviour_regenerate
  .globl sys_ai_behaviour_still_enemy
  .globl sys_ai_behaviour_explosion
  .globl sys_ai_update
  ;;.globl sys_ai_behaviour_mothership
  ;;.globl sys_ai_behaviour_autodestroy
  .globl sys_ai_behaviour_enemy
  .globl sys_ai_behaviour_enemy_arco_shot
  .globl sys_ai_behaviour_floating_enemy
  .globl sys_ai_behaviour_horizontal_enemy
  .globl sys_ai_behaviour_dashing_enemy
  .globl sys_ai_behaviour_teleporting_enemy
  .globl sys_ai_shot_pattern_single_shot
  .globl sys_ai_shot_pattern_vertical_shot
  .globl sys_ai_behaviour_boss_squid
  .globl sys_ai_behaviour_boss_crab
  .globl sys_ai_behaviour_boss_mechaKraken_tentacle_bottom
  .globl sys_ai_behaviour_boss_mechaKraken_tentacle_top
  .globl sys_ai_behaviour_boss_mechaKraken_head
  .globl sys_ai_shot_pattern_boss_squid_shot
  .globl sys_ai_shot_pattern_boss_crab_shot
  .globl sys_ai_shot_pattern_boss_mechaKraken_shot
  .globl sys_ai_shot_pattern_boss_mechaKraken_shot_2
  .globl sys_ai_shot_pattern_arco
  .globl sys_ai_shot_pattern_tripleShot
  .globl sys_ai_shot_pattern_shot_crab
  .globl sys_ai_shot_pattern_big_shot
  .globl sys_ai_shot_big_dead
  .globl sys_ai_shot_enemy
  .globl sys_ai_destroy_all_enemies
  .globl sys_ai_destroy_all_enemies_kraken
 ;ANIMATION GLOBALS
  .globl sys_animations_update
 ;COLLISIONS GLOBALS
  .globl sys_collisions_update
 ;INPUT GLOBALS
  .globl sys_input_checkPlayer
;

;VIDEO GLOBALS
 .globl _main_palette
 .globl _palette_menu
 .globl _palette_level_1
 .globl _palette_level_2
 .globl _palette_level_3
 .globl _palette_pulse_1
 .globl _palette_pulse_2
 .globl _palette_damage
 .globl _spr_playership
 .globl _spr_vacio
 .globl _spr_playership_up
 .globl _spr_playership_down
 .globl _spr_boss_crab_0
 .globl _spr_boss_crab_1
 .globl _spr_boss_crab_shot
 .globl _spr_boss_squid_0
 .globl _spr_boss_squid_1
 .globl _spr_boss_squid_shot
 .globl _spr_boss_squid_tentaculo_0
 .globl _spr_boss_squid_tentaculo_1
 .globl _spr_player_shot
 .globl _spr_enemy_shot1
 .globl _spr_enemy_big_shot
 .globl _spr_follow_shot
 .globl _spr_puffer_fish_0
 .globl _spr_puffer_fish_1
 .globl _spr_anguila_0
 .globl _spr_anguila_1
 .globl _spr_anguila_2
 .globl _spr_starfish_0
 .globl _spr_starfish_1
 .globl _spr_depths_fish_0
 .globl _spr_depths_fish_1
 .globl _spr_depths_fish_2
 .globl _spr_depths_fish_3
 .globl _spr_jellyfish_0
 .globl _spr_jellyfish_1
 .globl _spr_pez_pelicano_0
 .globl _spr_pez_pelicano_1
 .globl _spr_pez_pelicano_2
 .globl _spr_mecha_kraken_0
 .globl _spr_mecha_kraken_1
 .globl _spr_mecha_kraken_shot
 .globl _spr_torpedo
 .globl _spr_wheel_0
 .globl _spr_wheel_1
 .globl _spr_flotador_0
 .globl _spr_flotador_1
 .globl _spr_nautilus_0
 .globl _spr_nautilus_1
 .globl _spr_mecha_chalote_0
 .globl _spr_mecha_chalote_1
 .globl _spr_mecha_kraken_tentaculo_up_punta_0
 .globl _spr_mecha_kraken_tentaculo_up_punta_1
 .globl _spr_mecha_kraken_tentaculo_down_punta_0
 .globl _spr_mecha_kraken_tentaculo_down_punta_1
 .globl _spr_enemy_mega_shot
 .globl _spr_larcenas_0
 .globl _spr_larcenas_1
 .globl _spr_mina_0
 .globl _spr_mina_1
 .globl _spr_rocks
 .globl _spr_explosion_0
 .globl _spr_explosion_1
 .globl _spr_explosion_2
 .globl _spr_title

;TEMPLATE GLOBALS
 ;;.globl mothership_template
 .globl enemy_puffer_fish_template
 .globl enemy_anguila_template
 .globl enemy_anguila_dead_template
 .globl enemy_starfish_template
 .globl enemy_depths_fish_template
 .globl enemy_depths_fish_dead_template
 .globl enemy_jellyfish_template
 .globl enemy_pez_pelicano_template
 .globl wheel_template
 .globl mina_template
 .globl larcenas_template
 .globl flotador_template
 .globl enemy_nautilus_template
 .globl enemy_mecha_chalote_template
 .globl boss_squid_template
 .globl boss_squid_dead_template
 .globl boss_squid_tentacle_template
 .globl boss_crab_template
 .globl boss_mechaKraken_tentacle_bottom_punta_template
 .globl boss_mechaKraken_tentacle_top_punta_template
 .globl boss_mechaKraken_head_template
 ;;.globl playership_template
 .globl player_template
 ;;.globl playershot_template
 .globl shot_player_template
 .globl shot_enemy_template
 .globl big_shot_enemy_template
 .globl mega_shot_enemy_template
 .globl shot_enemy_vertical_template
 .globl shot_follow_template
 .globl enemy_follow_template
 .globl enemy_explosion_template


 .globl enemy_array
