;MIT License
;
;Copyright (c) 2022 cabbage_corp / Alberto Rius Poveda (@ariusp) / Alfonso Ruiz MartÃ­nez (@NexiriusRM) / Eliseo Fuentes MartÃ­nez (@efm18)
;
;Permission is hereby granted, free of charge, to any person obtaining a copy
;of this software and associated documentation files (the "Software"), to deal
;in the Software without restriction, including without limitation the rights
;to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;copies of the Software, and to permit persons to whom the Software is
;furnished to do so, subject to the following conditions:
;
;The above copyright notice and this permission notice shall be included in all
;copies or substantial portions of the Software.
;
;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;SOFTWARE.

;; Include all CPCtelera constant definitions, macros and variables
.include "man/entity.inc"
.include "globals.inc"
.include "cpctelera.h.s"
;;
;; Start of _DATA area 
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
;;
.area _DATA

uncontador:
   .db 6
;

.area _CODE

int_handler:
   push af
   push bc
   push de
   push hl
   push ix
   push iy

   ld   a, (uncontador)
   dec  a
   jr   nz, cont

   zero:
;;   cpctm_setBorder_asm HW_BRIGHT_WHITE

   guard:
;;   scf
;;   call c, cpct_akp_musicPlay_asm
   call cpct_akp_musicPlay_asm
   call cpct_scanKeyboard_if_asm

;;   ld   a, (_guard)
;;   xor  #0x80
;;   ld   (_guard), a

   ld   a, #6

   cont:
   ld   (uncontador), a

;;   ld   h, a
;;   ld   l, #16
;;   call cpct_setPALColour_asm

   pop  iy
   pop  ix
   pop  hl
   pop  de
   pop  bc
   pop  af

   ei
   reti
;

set_int_handler:
   ;; This is to ensure that this function is called before the
   ;; VSYNC section, so it will always wait until the exact
   ;; beginning of the VSYNC section
   call cpct_waitVSYNC_asm
   halt
   halt
   call cpct_waitVSYNC_asm

   ;; We load the interruption code into the memory
   ld   hl, #0x38
   ld   (hl), #0xC3
   inc  hl
   ld   (hl), #<int_handler
   inc  hl
   ld   (hl), #>int_handler
;;   inc  hl
;;   ld   (hl), #0xC9

   ret
;

;; 
;; Declare all function entry points as global symbols for the compiler.
;; (The linker will know what to do with them)
;; WARNING: Every global symbol declared will be linked, so DO NOT declare 
;; symbols for functions you do not use.
;;



_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   ;;call cpct_disableFirmware_asm
   call set_int_handler


   ld c,#0
   call cpct_setVideoMode_asm
   cpctm_setBorder_asm HW_BLACK

   restart_point:
   call man_menu_screen
   call man_menu_handler
   ld l,#0x30
   call cpct_setVideoMemoryPage_asm

   call man_game_init
   call man_game_play

   ;TODO LIMPIAR PANTALLA  
   ;(set4destruction -> for all)
   ;(render)
   ;(update entity)
   
   jr _main
   ret