;MIT License
;
;Copyright (c) 2022 cabbage_corp / Alberto Rius Poveda (@ariusp) / Alfonso Ruiz MartÃ­nez (@NexiriusRM) / Eliseo Fuentes MartÃ­nez (@efm18)
;
;Permission is hereby granted, free of charge, to any person obtaining a copy
;of this software and associated documentation files (the "Software"), to deal
;in the Software without restriction, including without limitation the rights
;to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;copies of the Software, and to permit persons to whom the Software is
;furnished to do so, subject to the following conditions:
;
;The above copyright notice and this permission notice shall be included in all
;copies or substantial portions of the Software.
;
;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;SOFTWARE.

.module Animations

.include "globals.inc"
.include "man/animations.inc"

.area _DATA

man_anim_enemy_puffer_fish::
    .db #ANIMATION_ENEMY_PUFFER_FISH_0_TIME
    .dw _spr_puffer_fish_0
    .db #ANIMATION_ENEMY_PUFFER_FISH_1_TIME
    .dw _spr_puffer_fish_1
    .db #0x00
    .dw man_anim_enemy_puffer_fish
    ret
;

man_anim_enemy_anguila::
    .db #ANIMATION_ENEMY_ANGUILA_0_TIME
    .dw _spr_anguila_0
    .db #ANIMATION_ENEMY_ANGUILA_1_TIME
    .dw _spr_anguila_1
    .db #ANIMATION_ENEMY_ANGUILA_2_TIME
    .dw _spr_anguila_2
    .db #ANIMATION_ENEMY_ANGUILA_1_TIME
    .dw _spr_anguila_1
    .db #0x00
    .dw man_anim_enemy_anguila
    ret
;

man_anim_enemy_starfish::
    .db #ANIMATION_ENEMY_STARFISH_0_TIME
    .dw _spr_starfish_0
    .db #ANIMATION_ENEMY_STARFISH_0_TIME
    .dw _spr_starfish_1
    .db #0x00
    .dw man_anim_enemy_starfish
    ret
;

man_anim_enemy_deptsh_fish::
    .db #ANIMATION_ENEMY_DEPTHS_FISH_0_TIME
    .dw _spr_depths_fish_0
    .db #ANIMATION_ENEMY_DEPTHS_FISH_1_TIME
    .dw _spr_depths_fish_1
    .db #ANIMATION_ENEMY_DEPTHS_FISH_2_TIME
    .dw _spr_depths_fish_2
    .db #ANIMATION_ENEMY_DEPTHS_FISH_3_TIME
    .dw _spr_depths_fish_3
    .db #0x00
    .dw man_anim_enemy_deptsh_fish
    ret
;

man_anim_enemy_jellyfish::
    .db #ANIMATION_ENEMY_JELLYFISH_0_TIME
    .dw _spr_jellyfish_0
    .db #ANIMATION_ENEMY_JELLYFISH_1_TIME
    .dw _spr_jellyfish_1
    .db #0x00
    .dw man_anim_enemy_jellyfish
    ret
;

man_anim_wheel::
    .db #ANIMATION_WHEEL_0_TIME
    .dw _spr_wheel_0
    .db #ANIMATION_WHEEL_1_TIME
    .dw _spr_wheel_1
    .db #0x00
    .dw man_anim_wheel
    ret
;

man_anim_mina::
    .db #ANIMATION_MINA_0_TIME
    .dw _spr_mina_0
    .db #ANIMATION_MINA_1_TIME
    .dw _spr_mina_1
    .db #0x00
    .dw man_anim_mina
    ret
;

man_anim_larcenas::
    .db #ANIMATION_LARCENAS_0_TIME
    .dw _spr_larcenas_0
    .db #ANIMATION_LARCENAS_1_TIME
    .dw _spr_larcenas_1
    .db #0x00
    .dw man_anim_larcenas
    ret
;

man_anim_flotador::
    .db #ANIMATION_FLOTADOR_0_TIME
    .dw _spr_flotador_0
    .db #ANIMATION_FLOTADOR_1_TIME
    .dw _spr_flotador_1
    .db #0x00
    .dw man_anim_flotador
    ret
;

man_anim_enemy_nautilus::
    .db #ANIMATION_ENEMY_NAUTILUS_0_TIME
    .dw _spr_nautilus_0
    .db #ANIMATION_ENEMY_NAUTILUS_1_TIME
    .dw _spr_nautilus_1
    .db #0x00
    .dw man_anim_enemy_nautilus
    ret
;

man_anim_enemy_mecha_chalote::
    .db #ANIMATION_ENEMY_MECHA_CHALOTE_0_TIME
    .dw _spr_mecha_chalote_0
    .db #ANIMATION_ENEMY_MECHA_CHALOTE_1_TIME
    .dw _spr_mecha_chalote_1
    .db #0x00
    .dw man_anim_enemy_mecha_chalote
    ret
;

man_anim_enemy_pez_pelicano::
    .db #ANIMATION_ENEMY_PEZ_PELICANO_0_TIME
    .dw _spr_pez_pelicano_0
    .db #ANIMATION_ENEMY_PEZ_PELICANO_1_TIME
    .dw _spr_pez_pelicano_1
    .db #ANIMATION_ENEMY_PEZ_PELICANO_2_TIME
    .dw _spr_pez_pelicano_2
    .db #ANIMATION_ENEMY_PEZ_PELICANO_1_TIME
    .dw _spr_pez_pelicano_1
    .db #0x00
    .dw man_anim_enemy_pez_pelicano
    ret
;

man_anim_follow::
    .db #0xFF
    .dw _spr_torpedo
    .db #0x00
    .dw man_anim_follow
;

man_anim_boss_crab::
    .db #ANIMATION_BOSS_CRAB_0_TIME
    .dw _spr_boss_crab_0
    .db #ANIMATION_BOSS_CRAB_1_TIME
    .dw _spr_boss_crab_1
    .db #0x00
    .dw man_anim_boss_crab
;

man_anim_boss_squid::
    .db #ANIMATION_BOSS_SQUID_0_TIME
    .dw _spr_boss_squid_0
    .db #ANIMATION_BOSS_SQUID_1_TIME
    .dw _spr_boss_squid_1
    .db #0x00
    .dw man_anim_boss_squid
;

man_anim_boss_squid_tentacle::
    .db #ANIMATION_BOSS_SQUID_TENTACLE_0_TIME
    .dw _spr_boss_squid_tentaculo_0
    .db #ANIMATION_BOSS_SQUID_TENTACLE_1_TIME
    .dw _spr_boss_squid_tentaculo_1
    .db #0x00
    .dw man_anim_boss_squid_tentacle
;

man_anim_boss_mecha_kraken::
    .db #ANIMATION_BOSS_MECHA_KRAKEN_0_TIME
    .dw _spr_mecha_kraken_0
    .db #ANIMATION_BOSS_MECHA_KRAKEN_1_TIME
    .dw _spr_mecha_kraken_1
    .db #0x00
    .dw man_anim_boss_mecha_kraken
;

man_anim_boss_mecha_kraken_tentacle_up_punta::
    .db #ANIMATION_BOSS_MECHA_KRAKEN_TENTACLE_UP_PUNTA_0_TIME
    .dw _spr_mecha_kraken_tentaculo_up_punta_0
    .db #ANIMATION_BOSS_MECHA_KRAKEN_TENTACLE_UP_PUNTA_1_TIME
    .dw _spr_mecha_kraken_tentaculo_up_punta_1
    .db #0x00
    .dw man_anim_boss_mecha_kraken_tentacle_up_punta
;


man_anim_boss_mecha_kraken_tentacle_down_punta::
    .db #ANIMATION_BOSS_MECHA_KRAKEN_TENTACLE_DOWN_PUNTA_0_TIME
    .dw _spr_mecha_kraken_tentaculo_down_punta_0
    .db #ANIMATION_BOSS_MECHA_KRAKEN_TENTACLE_DOWN_PUNTA_1_TIME
    .dw _spr_mecha_kraken_tentaculo_down_punta_1
    .db #0x00
    .dw man_anim_boss_mecha_kraken_tentacle_down_punta
;

man_anim_explosion::
    .db #6
    .dw _spr_explosion_2
    .db #8
    .dw _spr_explosion_1
    .db #10
    .dw _spr_explosion_0
    .db #8
    .dw _spr_explosion_1
    .db #6
    .dw _spr_explosion_2
    .db #0x00
    .dw man_anim_explosion
    ret
;

.area _CODE




