;MIT License
;
;Copyright (c) 2022 cabbage_corp / Alberto Rius Poveda (@ariusp) / Alfonso Ruiz MartÃ­nez (@NexiriusRM) / Eliseo Fuentes MartÃ­nez (@efm18)
;
;Permission is hereby granted, free of charge, to any person obtaining a copy
;of this software and associated documentation files (the "Software"), to deal
;in the Software without restriction, including without limitation the rights
;to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;copies of the Software, and to permit persons to whom the Software is
;furnished to do so, subject to the following conditions:
;
;The above copyright notice and this permission notice shall be included in all
;copies or substantial portions of the Software.
;
;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;SOFTWARE.

.module EntityTemplates

.include "man/entity.inc"
.include "globals.inc"
.include "man/entity_templates.inc"

.area _DATA

enemy_puffer_fish_template::
    .db #TYPE_ENEMY
    .db #Puffer_Fish_INIT_X
    .db #Puffer_Fish_INIT_Y
    .db #Puffer_Fish_VX
    .db #Puffer_Fish_VY
    .db #Puffer_Fish_W
    .db #Puffer_Fish_H
    .dw _spr_puffer_fish_0
    .dw 0x0000
    .dw #man_anim_enemy_puffer_fish
    .db #12
    .dw #sys_ai_shot_pattern_single_shot
    .dw #sys_ai_behaviour_enemy
    .db 0
    .dw 0x00
    .db 2
    .db 0
;

enemy_anguila_template::
    .db #TYPE_ENEMY
    .db #Anguila_INIT_X
    .db #Anguila_INIT_Y
    .db #Anguila_VX
    .db #Anguila_VY
    .db #Anguila_W
    .db #Anguila_H
    .dw _spr_anguila_0
    .dw 0x0000
    .dw #man_anim_enemy_anguila
    .db #12
    .dw #sys_ai_shot_pattern_single_shot
    .dw #sys_ai_behaviour_dashing_enemy
    .db 0
    .dw 0x00
    .db 8
    .db 0
;

enemy_anguila_dead_template::
    .db TYPE_ENEMY_SHOT + TYPE_DEAD
    .db #Anguila_INIT_X
    .db #Anguila_INIT_Y
    .db #Anguila_VX
    .db #Anguila_VY
    .db #Anguila_W
    .db #Anguila_H
    .dw _spr_anguila_0
    .dw 0x0000
    .db -16
;

enemy_starfish_template::
    .db #TYPE_ENEMY
    .db #Starfish_INIT_X
    .db #Starfish_INIT_Y
    .db #Starfish_VX
    .db #Starfish_VY
    .db #Starfish_W
    .db #Starfish_H
    .dw _spr_starfish_0
    .dw 0x0000
    .dw #man_anim_enemy_starfish
    .db #12
    .dw #sys_ai_shot_pattern_arco
    .dw #sys_ai_behaviour_enemy_arco_shot
    .db 0
    .dw 0x00
    .db 5
    .db 0
;


enemy_depths_fish_template::
    .db #TYPE_ENEMY
    .db #Depths_Fish_INIT_X
    .db #Depths_Fish_INIT_Y
    .db #Depths_Fish_VX
    .db #Depths_Fish_VY
    .db #Depths_Fish_W
    .db #Depths_Fish_H
    .dw _spr_depths_fish_0
    .dw 0x0000
    .dw #man_anim_enemy_deptsh_fish
    .db #16
    .dw #sys_ai_shot_pattern_arco
    .dw #sys_ai_behaviour_teleporting_enemy
    .db 0
    .dw 0x00
    .db 4
    .db 0
;

enemy_depths_fish_dead_template::
    .db TYPE_ENEMY_SHOT + TYPE_DEAD
    .db #Depths_Fish_INIT_X
    .db #Depths_Fish_INIT_Y
    .db #Depths_Fish_VX
    .db #Depths_Fish_VY
    .db #Depths_Fish_W
    .db #Depths_Fish_H
    .dw _spr_depths_fish_0
    .dw 0x0000
    .db -16
;

enemy_jellyfish_template::
    .db #TYPE_ENEMY
    .db #Jellyfish_INIT_X
    .db #Jellyfish_INIT_Y
    .db #Jellyfish_VX
    .db #Jellyfish_VY
    .db #Jellyfish_W
    .db #Jellyfish_H
    .dw _spr_jellyfish_0
    .dw 0x0000
    .dw #man_anim_enemy_jellyfish
    .db #12
    .dw #sys_ai_shot_pattern_tripleShot
    .dw #sys_ai_behaviour_teleporting_enemy
    .db 0
    .dw 0x00
    .db 3
    .db 0
;

enemy_pez_pelicano_template::
    .db #TYPE_ENEMY
    .db #Pez_Pelicano_INIT_X
    .db #Pez_Pelicano_INIT_Y
    .db #Pez_Pelicano_VX
    .db #Pez_Pelicano_VY
    .db #Pez_Pelicano_W
    .db #Pez_Pelicano_H
    .dw _spr_pez_pelicano_0
    .dw 0x0000
    .dw #man_anim_enemy_pez_pelicano
    .db #12
    .dw #sys_ai_shot_pattern_tripleShot
    .dw #sys_ai_behaviour_dashing_enemy
    .db 0           ;Contador temporal del enemigo, para frecuencia de disparo y calcular movimientos
    .dw 0x00        ;TODO Función para colisiones (puede que convenga tener una única y no usar esto)
    .db 8           ;TODO Rellenar con vida inicial
    .db 0
;

wheel_template::
    .db #TYPE_ENEMY
    .db #Wheel_INIT_X
    .db #Wheel_INIT_Y
    .db #Wheel_VX
    .db #Wheel_VY
    .db #Wheel_W
    .db #Wheel_H
    .dw _spr_wheel_0
    .dw 0x0000
    .dw #man_anim_wheel
    .db #12
    .dw 0x0000
    .dw #sys_ai_behaviour_floating_enemy
    .db 0
    .dw 0x00
    .db 2
    .db 0
;

mina_template::
    .db #TYPE_ENEMY
    .db #Mina_INIT_X
    .db #Mina_INIT_Y
    .db #Mina_VX
    .db #Mina_VY
    .db #Mina_W
    .db #Mina_H
    .dw _spr_mina_0
    .dw 0x0000
    .dw #man_anim_mina
    .db #12
    .dw 0x0000
    .dw #sys_ai_behaviour_floating_enemy
    .db 0
    .dw 0x00
    .db 2
    .db 0
;

larcenas_template::
    .db #TYPE_ENEMY
    .db #Larcenas_INIT_X
    .db #Larcenas_INIT_Y
    .db #Larcenas_VX
    .db #Larcenas_VY
    .db #Larcenas_W
    .db #Larcenas_H
    .dw _spr_larcenas_0
    .dw 0x0000
    .dw #man_anim_larcenas
    .db #12
    .dw 0x0000
    .dw #sys_ai_behaviour_floating_enemy
    .db 0
    .dw 0x00
    .db 2
    .db 0
;

flotador_template::
    .db #TYPE_ENEMY
    .db #Wheel_INIT_X
    .db #Wheel_INIT_Y
    .db #Wheel_VX
    .db #Wheel_VY
    .db #Wheel_W
    .db #Wheel_H
    .dw _spr_flotador_0
    .dw 0x0000
    .dw #man_anim_flotador
    .db #12
    .dw 0x0000
    .dw #sys_ai_behaviour_floating_enemy
    .db 0
    .dw 0x00
    .db 2
    .db 0
;

enemy_nautilus_template::
    .db #TYPE_ENEMY
    .db #Nautilus_INIT_X
    .db #Nautilus_INIT_Y
    .db #Nautilus_VX
    .db #Nautilus_VY
    .db #Nautilus_W
    .db #Nautilus_H
    .dw _spr_nautilus_0
    .dw 0x0000
    .dw #man_anim_enemy_nautilus
    .db #12
    .dw #sys_ai_shot_pattern_tripleShot
    .dw #sys_ai_behaviour_enemy
    .db 0
    .dw 0x00
    .db 6
    .db 0
;

enemy_mecha_chalote_template::
    .db #TYPE_ENEMY
    .db #Mecha_Chalote_INIT_X
    .db #Mecha_Chalote_INIT_Y
    .db #Mecha_Chalote_VX
    .db #Mecha_Chalote_VY
    .db #Mecha_Chalote_W
    .db #Mecha_Chalote_H
    .dw _spr_mecha_chalote_0
    .dw 0x0000
    .dw #man_anim_enemy_mecha_chalote
    .db #12
    .dw #sys_ai_shot_enemy
    .dw #sys_ai_behaviour_still_enemy
    .db 0
    .dw 0x00
    .db 10
    .db 0
;

enemy_follow_template::
    .db #TYPE_ENEMY
    .db 0
    .db 0
    .db -1
    .db 0
    .db #follow_shot_W
    .db #follow_shot_H
    .dw _spr_torpedo
    .dw 0x0000
    .dw #man_anim_follow
    .db #0xFF
    .dw #sys_ai_shot_big_dead
    .dw #sys_ai_behaviour_enemy_follow
    .db 0           ;Contador temporal del enemigo, para frecuencia de disparo y calcular movimientos
    .dw 0x00        ;TODO Función para colisiones (puede que convenga tener una única y no usar esto)
    .db 255           ;TODO Rellenar con vida inicial
    .db 0
;

boss_crab_template::
    .db #TYPE_ENEMY
    .db #Boss_Crab_INIT_X
    .db #Boss_Crab_INIT_Y
    .db #Boss_Crab_VX
    .db #Boss_Crab_VY
    .db #Boss_Crab_W
    .db #Boss_Crab_H
    .dw _spr_boss_crab_0
    .dw 0x0000
    .dw #man_anim_boss_crab
    .db #12
    .dw #sys_ai_shot_pattern_boss_crab_shot
    .dw #sys_ai_behaviour_boss_crab
    .db 0           ;Contador temporal del enemigo, para frecuencia de disparo y calcular movimientos
    .dw 0x00        ;TODO Función para colisiones (puede que convenga tener una única y no usar esto)
    .db 32          ;TODO Rellenar con vida inicial
    .db 0
;

boss_squid_template::
    .db #TYPE_ENEMY
    .db #Boss_Squid_INIT_X
    .db #Boss_Squid_INIT_Y
    .db #Boss_Squid_VX
    .db #Boss_Squid_VY
    .db #Boss_Squid_W
    .db #Boss_Squid_H
    .dw _spr_boss_squid_0
    .dw 0x0000
    .dw #man_anim_boss_squid
    .db #12
    .dw #sys_ai_shot_pattern_boss_squid_shot
    .dw #sys_ai_behaviour_boss_squid
    .db 0           ;Contador temporal del enemigo, para frecuencia de disparo y calcular movimientos
    .dw sys_ai_destroy_all_enemies        ;TODO Función para colisiones (puede que convenga tener una única y no usar esto)
    .db 32           ;TODO Rellenar con vida inicial
    .db 0
;

boss_squid_dead_template::
    .db TYPE_ENEMY_SHOT + TYPE_DEAD
    .db #Boss_Squid_INIT_X
    .db #Boss_Squid_INIT_Y
    .db #Boss_Squid_VX
    .db #Boss_Squid_VY
    .db #Boss_Squid_W
    .db #Boss_Squid_H
    .dw _spr_boss_squid_0
    .dw 0x0000
    .db -16
;

boss_squid_tentacle_template::
    .db #TYPE_ENEMY
    .db #Boss_Squid_Tentacle_INIT_X
    .db #Boss_Squid_Tentacle_INIT_Y
    .db #Boss_Squid_Tentacle_VX
    .db #Boss_Squid_Tentacle_VY
    .db #Boss_Squid_Tentacle_W
    .db #Boss_Squid_Tentacle_H
    .dw _spr_boss_squid_tentaculo_0
    .dw 0x0000
    .dw #man_anim_boss_squid_tentacle
    .db #12
    .dw 0x0000
    .dw #sys_ai_behaviour_floating_enemy
    .db 0
    .dw 0x00
    .db 2
    .db 0
;

boss_mechaKraken_tentacle_bottom_punta_template::
    .db #TYPE_ENEMY
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_INIT_X
    .db #Boss_Mecha_Kraken_Tentaculo_Bottom_Punta_INIT_Y
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_VX
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_VY
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_W
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_H
    .dw _spr_mecha_kraken_tentaculo_down_punta_0
    .dw 0x0000
    .dw #man_anim_boss_mecha_kraken_tentacle_down_punta
    .db #12
    .dw 0x0000
    .dw #sys_ai_behaviour_boss_mechaKraken_tentacle_bottom
    .db 0           ;Contador temporal del enemigo, para frecuencia de disparo y calcular movimientos
    .dw 0x00        ;TODO Función para colisiones (puede que convenga tener una única y no usar esto)
    .db #255        ;TODO Rellenar con vida inicial
    .db 0
;

boss_mechaKraken_tentacle_top_punta_template::
    .db #TYPE_ENEMY
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_INIT_X
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_INIT_Y
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_VX
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_VY
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_W
    .db #Boss_Mecha_Kraken_Tentaculo_Up_Punta_H
    .dw _spr_mecha_kraken_tentaculo_up_punta_0
    .dw 0x0000
    .dw #man_anim_boss_mecha_kraken_tentacle_up_punta
    .db #12
    .dw 0x0000
    .dw #sys_ai_behaviour_boss_mechaKraken_tentacle_top
    .db 0           ;Contador temporal del enemigo, para frecuencia de disparo y calcular movimientos
    .dw 0x00        ;TODO Función para colisiones (puede que convenga tener una única y no usar esto)
    .db #255        ;TODO Rellenar con vida inicial
    .db 0
;


boss_mechaKraken_head_template::
    .db #TYPE_ENEMY
    .db #Boss_Mecha_Kraken_Head_INIT_X
    .db #Boss_Mecha_Kraken_Head_INIT_Y
    .db #Boss_Mecha_Kraken_Head_VX
    .db #Boss_Mecha_Kraken_Head_VY
    .db #Boss_Mecha_Kraken_Head_W
    .db #Boss_Mecha_Kraken_Head_H
    .dw _spr_mecha_kraken_0
    .dw 0x0000
    .dw #man_anim_boss_mecha_kraken
    .db #12
    .dw #sys_ai_shot_pattern_boss_mechaKraken_shot
    .dw #sys_ai_behaviour_boss_mechaKraken_head
    .db 0           ;Contador temporal del enemigo, para frecuencia de disparo y calcular movimientos
    .dw #sys_ai_destroy_all_enemies_kraken        ;TODO Función para colisiones (puede que convenga tener una única y no usar esto)
    .db #63        ;TODO Rellenar con vida inicial
    .db 0
;


player_template::
    .db #TYPE_PLAYER
    .db #PlayerShip_0_INIT_X
    .db #PlayerShip_0_INIT_Y
    .db #PlayerShip_0_VX
    .db #PlayerShip_0_VY
    .db #PlayerShip_0_W
    .db #PlayerShip_0_H
    .dw _spr_playership
    .dw 0x0000
    .db #PlayerShip_0_INIT_HEALTH
    .db 0
    .db 0
;

shot_player_template::
    .db #TYPE_PLAYER_SHOT       ;TODO Se debe rellenar el tipo al crearse
    .db #player_shot_INIT_X
    .db #player_shot_INIT_Y
    .db #player_shot_VX
    .db #player_shot_VY
    .db #player_shot_W   
    .db #player_shot_H
    .dw _spr_player_shot
    .dw 0x0000
    .db 0
;

shot_enemy_template::
    .db #TYPE_ENEMY_SHOT       ;TODO Se debe rellenar el tipo al crearse
    .db #enemy_shot_INIT_X
    .db #enemy_shot_INIT_Y
    .db #enemy_shot_VX
    .db #enemy_shot_VY
    .db #enemy_shot_W
    .db #enemy_shot_H
    .dw _spr_enemy_shot1
    .dw 0x0000
    .db -16
;
shot_follow_template::
    .db TYPE_ENEMY_SHOT + TYPE_DEAD
    .db #follow_shot_INIT_X
    .db #follow_shot_INIT_Y
    .db #follow_shot_VX
    .db #follow_shot_VY
    .db #follow_shot_W
    .db #follow_shot_H
    .dw _spr_torpedo
    .dw 0x0000
    .db -16
;

shot_enemy_vertical_template::
    .db #TYPE_ENEMY_SHOT       ;TODO Se debe rellenar el tipo al crearse
    .db #Vshot_0_INIT_X
    .db #Vshot_0_INIT_Y
    .db #Vshot_0_VX
    .db #Vshot_0_VY
    .db #Vshot_W
    .db #Vshot_W
    .dw _spr_enemy_shot1
    .dw 0x0000
    .db 0
;

big_shot_enemy_template::
    .db #TYPE_ENEMY_SHOT       ;TODO Se debe rellenar el tipo al crearse
    .db #enemy_big_shot_INIT_X
    .db #enemy_big_shot_INIT_Y
    .db #enemy_big_shot_VX
    .db #enemy_big_shot_VY
    .db #enemy_big_shot_W
    .db #enemy_big_shot_H
    .dw _spr_enemy_big_shot
    .dw 0x0000
    .db -32
;

mega_shot_enemy_template::
    .db #TYPE_ENEMY_SHOT       ;TODO Se debe rellenar el tipo al crearse
    .db #enemy_mega_shot_INIT_X
    .db #enemy_mega_shot_INIT_Y
    .db #enemy_mega_shot_VX
    .db #enemy_mega_shot_VY
    .db #enemy_mega_shot_W
    .db #enemy_mega_shot_H
    .dw _spr_enemy_mega_shot
    .dw 0x0000
    .db -32
;
enemy_explosion_template::
    .db #TYPE_ENEMY
    .db 0
    .db 0
    .db #EXPLOSION_VX
    .db #EXPLOSION_VY
    .db #EXPLOSION_W 
    .db #EXPLOSION_H 
    .dw _spr_explosion_2
    .dw 0x0000
    .dw #man_anim_explosion
    .db #6
    .dw 0x0000
    .dw #sys_ai_behaviour_explosion
    .db 0           ;Contador temporal del enemigo, para frecuencia de disparo y calcular movimientos
    .dw 0x00        ;TODO Función para colisiones (puede que convenga tener una única y no usar esto)
    .db 255           ;TODO Rellenar con vida inicial
    .db 0
;

.area _CODE
