;MIT License
;
;Copyright (c) 2022 cabbage_corp / Alberto Rius Poveda (@ariusp) / Alfonso Ruiz MartÃ­nez (@NexiriusRM) / Eliseo Fuentes MartÃ­nez (@efm18)
;
;Permission is hereby granted, free of charge, to any person obtaining a copy
;of this software and associated documentation files (the "Software"), to deal
;in the Software without restriction, including without limitation the rights
;to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;copies of the Software, and to permit persons to whom the Software is
;furnished to do so, subject to the following conditions:
;
;The above copyright notice and this permission notice shall be included in all
;copies or substantial portions of the Software.
;
;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;SOFTWARE.

.module Animations

.include "globals.inc"
.include "man/entity.inc"

.area _DATA
.area _CODE

sys_animations_update_one_entity::
    dec     enemy_animCounter(ix)
    jr      NZ, end_if_anim_counter ;If counter != 0 Skip

        ld l,enemy_animFramePtr(ix)
        ld h,1+enemy_animFramePtr(ix)   ;Load pointer to animation in HL

        inc hl
        inc hl
        inc hl
        ld a,(hl)                       ;If next counter == 0
        or      a
        jr      NZ, end_if_anim_time    ;Skip frame
         inc hl
         ld e,(hl)
         inc hl
         ld d,(hl)
         ex de,hl

        end_if_anim_time:
            inc hl
            ld d,(hl)
            ld entity_spritePtr(ix),d        ;Update sprite pointer low byte
            inc hl
            ld d,(hl)
            ld 1+entity_spritePtr(ix),d      ;Update sprite pointer high byte
            dec hl
            dec hl

            ld d,(hl)
            ld enemy_animCounter(ix),d      ;Initialise next counter
            ld enemy_animFramePtr(ix),l     ;Load new anim address to entity
            ld 1+enemy_animFramePtr(ix),h   ;

    end_if_anim_counter:
        ret



sys_animations_update::
    ld      hl, #sys_animations_update_one_entity
    ld      a, #TYPE_ENEMY
    call    man_entity_forAll_matching
    ret
;
