;MIT License
;
;Copyright (c) 2022 cabbage_corp / Alberto Rius Poveda (@ariusp) / Alfonso Ruiz MartÃ­nez (@NexiriusRM) / Eliseo Fuentes MartÃ­nez (@efm18)
;
;Permission is hereby granted, free of charge, to any person obtaining a copy
;of this software and associated documentation files (the "Software"), to deal
;in the Software without restriction, including without limitation the rights
;to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;copies of the Software, and to permit persons to whom the Software is
;furnished to do so, subject to the following conditions:
;
;The above copyright notice and this permission notice shall be included in all
;copies or substantial portions of the Software.
;
;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;SOFTWARE.

.module Physics

.include "man/entity.inc"
.include "sys/render.inc"
.include "man/entity_templates.inc"
.include "globals.inc"
.include "cpctelera.h.s"

.area _DATA



.area _CODE


;Entity to update goes in IX
;Destroys AF,BC,DE,HL
sys_physics_update_one_entity:
    ld a,entity_type(ix)
    cp #TYPE_PLAYER
    jr nz, update
    call sys_input_checkPlayer
    update:

    ld a, entity_x(ix)
    add a, entity_vx(ix)
    ld entity_x(ix),a
    ld e,a

    ld a,#RIGHT_BOUND
    sub entity_width(ix)
    cp e
    jr nc, actualiza_y
     call man_entity_set4Destruction
    ret
    actualiza_y:
    ld a, entity_y(ix)
    add a, entity_vy(ix)
    ld entity_y(ix),a
    ld e,a

    ld a,#BOTTOM_BOUND
    sub entity_height(ix)
    cp e
    ret nc
     call man_entity_set4Destruction
    ret
;

sys_physics_update::
    ld hl, #sys_physics_update_one_entity
    call man_entity_forAll
    ret
;
